From f3e66ffec3a8fd871ee0b7a3778ac59f38eec04c Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 10 2017 18:12:49 +0000
Subject: [PATCH 790/1001] Implement the config panel UI


---

diff --git a/hubs/static/client/app/components/Tab.jsx b/hubs/static/client/app/components/Tab.jsx
new file mode 100644
index 0000000..976e04b
--- /dev/null
+++ b/hubs/static/client/app/components/Tab.jsx
@@ -0,0 +1,21 @@
+import React from 'react';
+
+
+export default class Tab extends React.Component {
+  render() {
+    return (
+      <li role="presentation">
+        <a href="#" role="tab"
+           className={"nav-link" + (this.props.active ? " active" : "")}
+           onClick={this.props.linkClicked}
+           >
+          {this.props.children}
+        </a>
+      </li>
+    );
+  }
+}
+
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/TabPanel.jsx b/hubs/static/client/app/components/TabPanel.jsx
new file mode 100644
index 0000000..7d3a4ee
--- /dev/null
+++ b/hubs/static/client/app/components/TabPanel.jsx
@@ -0,0 +1,16 @@
+import React from 'react';
+
+
+export default class TabPanel extends React.Component {
+  render() {
+    return (
+      <div role="tabpanel"
+           className={"tab-pane" + (this.props.active ? " active" : "")}>
+        {this.props.children}
+      </div>
+    );
+  }
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/TabSet.jsx b/hubs/static/client/app/components/TabSet.jsx
new file mode 100644
index 0000000..df63568
--- /dev/null
+++ b/hubs/static/client/app/components/TabSet.jsx
@@ -0,0 +1,60 @@
+import React from 'react';
+import Tab from './Tab.jsx';
+import TabPanel from './TabPanel.jsx';
+
+
+export default class TabSet extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      activeTab: 0
+    }
+  }
+
+  linkClicked(e, index) {
+    e.preventDefault();
+    this.setState({activeTab: index});
+  }
+
+  render() {
+    var tabLinks = this.props.children.map(function(panel, index) {
+      return (
+        <Tab active={this.state.activeTab === index}
+             linkClicked={(e) => this.linkClicked(e, index)}
+             key={index.toString()}>
+          {panel.props.tabTitle}
+        </Tab>
+        );
+    }.bind(this));
+
+    var tabPanels = this.props.children.map(function(panel, index) {
+      return (
+        <TabPanel
+          active={this.state.activeTab === index}
+          key={index.toString()}>
+          {panel}
+        </TabPanel>
+        );
+    }.bind(this));
+
+    return (
+      <div>
+        <ul role="tablist"
+            className={"nav nav-tabs " + this.props.tabListClass || ""}
+            >
+          {tabLinks}
+        </ul>
+        <div
+          className={"tab-content " + this.props.tabContentClass || ""}
+          >
+          {tabPanels}
+        </div>
+      </div>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/core/HubConfig.jsx b/hubs/static/client/app/core/HubConfig.jsx
index 0471611..dcc54d5 100644
--- a/hubs/static/client/app/core/HubConfig.jsx
+++ b/hubs/static/client/app/core/HubConfig.jsx
@@ -1,17 +1,216 @@
 import React from 'react';
-import Panel from '../components/Panel.jsx';
+import {
+  IntlProvider,
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import {ChatPanel, NotImplementedPanel} from './HubConfigPanel.jsx';
+import TabSet from '../components/TabSet.jsx';
+
+
+const messages = defineMessages({
+  title: {
+    id: "hubs.core.config.title",
+    defaultMessage: "Hub settings",
+  },
+  general: {
+    id: "hubs.core.config.general",
+    defaultMessage: "General",
+  },
+  owners: {
+    id: "hubs.core.config.owners",
+    defaultMessage: "Owners",
+  },
+  members: {
+    id: "hubs.core.config.members",
+    defaultMessage: "Members",
+  },
+  chat: {
+    id: "hubs.core.config.chat",
+    defaultMessage: "Chat",
+  },
+  other: {
+    id: "hubs.core.config.other",
+    defaultMessage: "Other",
+  },
+  close: {
+    id: "hubs.core.config.close",
+    defaultMessage: "Close",
+  },
+  save_changes: {
+    id: "hubs.core.config.save_changes",
+    defaultMessage: "Save changes",
+  },
+});
 
 
 
 export default class HubConfig extends React.Component {
 
-  //constructor(props) {
-  //  super(props);
-  //}
+  constructor(props) {
+    super(props);
+    this.state = {
+      hubConfig: {},
+      generalConfig: {},
+      error: null,
+      loading: false
+    }
+    this.serverRequest = null;
+    this.handleSubmit = this.handleSubmit.bind(this);
+    this.handleChange = this.handleChange.bind(this);
+    this.loadState = this.loadState.bind(this);
+    this.pushState = this.pushState.bind(this);
+    //this.componentWillUpdate = this.componentWillUpdate.bind(this);
+  }
+
+	loadState() {
+    this.setState({loading: true});
+    this.serverRequest = $.ajax({
+      url: this.props.url,
+      method: 'GET',
+      dataType: 'json',
+      cache: false,
+      success: function(data) {
+        this.setState({
+          hubConfig: data.result.hub,
+          generalConfig: data.result.general,
+          error: null,
+          loading: false
+				});
+      }.bind(this),
+      error: function(xhr, status, err) {
+        console.error(this.props.url, status, err.toString());
+        this.setState({
+          error: err.toString(),
+          loading: false
+        });
+      }.bind(this)
+    });
+  }
+
+  pushState() {
+    this.setState({loading: true});
+    this.serverRequest = $.ajax({
+      url: this.props.url,
+      method: 'POST',
+      data: this.state.hubConfig,
+      dataType: 'json',
+      cache: false,
+      success: function(data) {
+        this.setState({
+          hubConfig: data.result.hub,
+          generalConfig: data.result.general,
+          error: null,
+          loading: false
+        });
+      }.bind(this),
+      error: function(xhr, status, err) {
+        console.error(this.props.url, status, err.toString());
+        this.setState({
+          error: err.toString(),
+          loading: false
+        });
+      }.bind(this)
+    });
+  }
+
+  handleChange(e) {
+    var config = this.state.hubConfig;
+    config[e.target.name] = e.target.value;
+    this.setState({hubConfig: config});
+  }
+
+  handleSubmit(e) {
+    e.preventDefault();
+    this.pushState();
+  }
+
+	componentDidMount() {
+		this.loadState();
+  }
+
+	componentWillUnmount() {
+		if (this.serverRequest) { this.serverRequest.abort(); }
+  }
 
   render() {
     return (
-      <Panel/>
+      <IntlProvider locale={navigator.language}>
+        <div className="modal-dialog modal-lg" role="document">
+          <div className="modal-content">
+            <form
+              method="post" action={this.props.url}
+              onSubmit={this.handleSubmit}
+              ref={(ref) => this.formDom = ref}
+              >
+              <div className="modal-header">
+                <button type="button" className="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
+                <h4 className="modal-title">
+                  <FormattedMessage {...messages.title} />
+                </h4>
+              </div>
+              <div className="modal-body">
+                <div className="row">
+                  <TabSet
+                    tabListClass="col-md-3"
+                    tabContentClass="col-md-9"
+                    >
+                    <NotImplementedPanel
+                      tabTitle={<FormattedMessage {...messages.general} />}
+                      />
+                    <NotImplementedPanel
+                      tabTitle={<FormattedMessage {...messages.owners} />}
+                      />
+                    <NotImplementedPanel
+                      tabTitle={<FormattedMessage {...messages.members} />}
+                      />
+                    <ChatPanel
+                      hubConfig={this.state.hubConfig}
+                      generalConfig={this.state.generalConfig}
+                      tabTitle={<FormattedMessage {...messages.chat} />}
+                      handleChange={this.handleChange}
+                      />
+                    <NotImplementedPanel
+                      tabTitle={<FormattedMessage {...messages.other} />}
+                      />
+                  </TabSet>
+                </div>
+              </div>
+              <div className="modal-footer">
+                <span
+                  className="loading"
+                  style={this.state.loading ? {display: "inline-block"} : {display: "none"}}
+                  ></span>
+                <button
+                  type="button"
+                  className="btn btn-default"
+                  data-dismiss="modal"
+                  disabled={this.state.loading}
+                  >
+                  <FormattedMessage {...messages.close} />
+                </button>
+                <button type="button" className="btn btn-primary"
+                        onClick={this.handleSubmit}>
+                  <FormattedMessage {...messages.save_changes} />
+                </button>
+                { this.state.error &&
+                  <div
+                    className="alert alert-danger" role="alert"
+                    style={{
+                      margin: "0em 1em",
+                      //textAlign: "center",
+                      display: "inline-block",
+                      padding: "0.375rem",
+                      }}
+                    >
+                    { this.state.error }
+                  </div>
+                }
+              </div>
+            </form>
+          </div>
+        </div>
+      </IntlProvider>
     );
   }
 
diff --git a/hubs/static/client/app/core/HubConfigPanel.jsx b/hubs/static/client/app/core/HubConfigPanel.jsx
new file mode 100644
index 0000000..920b184
--- /dev/null
+++ b/hubs/static/client/app/core/HubConfigPanel.jsx
@@ -0,0 +1,115 @@
+import React from 'react';
+import {
+  IntlProvider,
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import TabPanel from '../components/TabPanel.jsx';
+
+
+const messages = defineMessages({
+  chat_title: {
+    id: "hubs.core.config.chat.title",
+    defaultMessage: "Chat Settings",
+  },
+  chat_intro_1: {
+    id: "hubs.core.config.chat.intro1",
+    defaultMessage: "If your team or project has an IRC channel associated with it, you can connect this hub to it via the Hubs chat widget.",
+  },
+  chat_intro_2: {
+    id: "hubs.core.config.chat.intro2",
+    defaultMessage: "Please indicate your team's IRC channel below:",
+  },
+  chat_channel_name: {
+    id: "hubs.core.config.chat.channel_name",
+    defaultMessage: "Channel name",
+  },
+  chat_example: {
+    id: "hubs.core.config.chat.example",
+    defaultMessage: "Example:",
+  },
+  chat_network: {
+    id: "hubs.core.config.chat.network",
+    defaultMessage: "IRC network",
+  },
+});
+
+
+export class NotImplementedPanel extends React.Component {
+
+  render() {
+    return (
+      <div>
+        Not implemented yet.
+      </div>
+    );
+  }
+
+}
+
+export class ChatPanel extends React.Component {
+
+  render() {
+    var networks = [],
+        channel = "#",
+        //stillLoading = (typeof this.props.hubConfig.chat_channel === "undefined");
+        stillLoading = (
+          typeof this.props.generalConfig.chat_networks === "undefined"
+          );
+    if (this.props.hubConfig.chat_channel) {
+      channel = "#" + this.props.hubConfig.chat_channel.replace(/^#*/, "");
+    }
+    if (this.props.generalConfig.chat_networks) {
+      networks = this.props.generalConfig.chat_networks.map(
+        function(network, index) {
+          return (
+            <option value={network.domain} key={network.domain}>
+              {network.name} - {network.domain}
+            </option>
+          );
+        }.bind(this)
+      );
+    }
+    return (
+      <div>
+        <FormattedMessage {...messages.chat_title} tagName="h3" />
+        <FormattedMessage {...messages.chat_intro_1} tagName="p" />
+        <FormattedMessage {...messages.chat_intro_2} tagName="p" />
+        <div className="form-group">
+          <label htmlFor="hub-settings-chat-channel">
+            <FormattedMessage {...messages.chat_channel_name} />
+          </label>
+          <input
+            type="text" className="form-control" name="chat_channel"
+            id="hub-settings-chat-channel"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={channel}
+            />
+          <p className="form-text text-muted">
+            <FormattedMessage {...messages.chat_example} tagName="strong" />
+            <span style={{marginLeft: "0.5em"}}>#fedora-devel</span>
+          </p>
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-chat-domain">
+            <FormattedMessage {...messages.chat_network} />
+          </label>
+          <select
+            name="chat_domain" className="form-control"
+            id="hub-settings-chat-domain"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.chat_domain || ""}
+            >
+            {networks}
+          </select>
+        </div>
+      </div>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 65f2449..128d50a 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -139,3 +139,25 @@ def hub_edit_post(name):
             return ('ok', 200)
     else:
         return flask.redirect(flask.url_for('hub', name=name))
+
+
+@app.route('/<name>/config', methods=['GET', 'POST'])
+@login_required
+def hub_config(name):
+    hub = get_hub(name)
+    config = {
+        "status": "OK",
+        "result": {
+            "hub": hub.name,
+            },
+        }
+    if flask.request.method == 'POST':
+        for key, value in flask.request.form.items():
+            hub.config[key] = value
+        try:
+            flask.g.db.commit()
+        except Exception as err:
+            config = {"status": "ERROR", "message": str(err)}
+            return flask.jsonify(config), 400
+    config["result"].update(hub.config.__json__())
+    return flask.jsonify(config)

